# Contributing to csscss

First of all: Thanks!

## Bugs & Feature Requests

You can file bugs on the [issues
tracker](https://github.com/zmoazeni/csscss/issues), and tag them with
'bug'. Feel free to discuss features there, too.

## Good report structure

Please include the following four things in your report:

1. The smallest CSS snippet to explain the problem.
2. What you did.
3. What you expected to happen.
4. What happened instead.

The more information the better.

## Contributing Code

It's easy to contribute code to csscss:

1. Fork csscss.
2. Create a topic branch - `git checkout -b my_branch`
3. Push to your branch - `git push origin my_branch`
4. Make sure the code follows the contributing guidelines below.
5. Create a [Pull Request](http://help.github.com/pull-requests/) from your
   branch.
6. That's it!

## First Time OSS Contributors

Submitting your first pull request can be a little daunting. If this is
your first Open Source contribution, please mention it in your pull
request and I'll help guide you through the process.

## Contributing Guidelines

* Make sure your code follows typical [ruby
conventions](https://github.com/bbatsov/ruby-style-guide).
* Make sure the test suite is green. A simple `bundle exec rake test`
will run all the tests.
* Include a CHANGELOG entry with your change. Add an `(Unreleased)`
section at the top if one doesn't exist.
* Try to keep the git commits squashed and concise. Keep tests and code
changes together in the same commit. Keep only logical changes together
in a single commit.
* I strongly encourage [well written git commit
messages](http://tbaggery.com/2008/04/19/a-note-about-git-commit-messages.html).
* Make sure all whitespace is trimmed from the end of lines.
